# define errors (-1)
# define no_errors 0

# include <stdlib.h>
# include <string.h>
# include <stdio.h>


#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <OpenAL/al.h>
#include <OpenAL/alc.h>



#define CASE_RETURN(err) case (err): return "##err"
const char* al_err_str(ALenum err) {
    switch(err) {
        CASE_RETURN(AL_NO_ERROR);
        CASE_RETURN(AL_INVALID_NAME);
        CASE_RETURN(AL_INVALID_ENUM);
        CASE_RETURN(AL_INVALID_VALUE);
        CASE_RETURN(AL_INVALID_OPERATION);
        CASE_RETURN(AL_OUT_OF_MEMORY);
    }
    return "unknown";
}
#undef CASE_RETURN

#define __al_check_error(file,line) \
    do { \
        ALenum err = alGetError(); \
        for(; err!=AL_NO_ERROR; err=alGetError()) { \
            std::cerr << "AL Error " << al_err_str(err) << " at " << file << ":" << line << std::endl; \
        } \
    }while(0)

#define al_check_error() \
    __al_check_error(__FILE__, __LINE__)




ALuint src = 0;
ALuint buf = 0;

int array_size=882*4*10;
char * array;
int array_pos = 0;


void play(char * Buffer, int Len)
{
    static int first = 1;

    memcpy(&array[array_pos], Buffer, Len);
    array_pos+=Len;
    
    
    if (array_pos!=array_size)
    {
	return;
    }
    
    array_pos = 0;
    
    int pos;
    
    
    if (first)
    first = 0;
    else
    {
    LN:
//    nanosleep(5000000);

    
    alGetSourcei(src, AL_SAMPLE_OFFSET, &pos);

    //printf ("%d\n", pos);

    if (pos!=array_size/4)
	goto LN;
    }
    
    if (src)
    {
	alDeleteSources(1, &src);
	al_check_error();
    }
    
    if (buf)
    {
	alDeleteBuffers(1, &buf);
	al_check_error();
    }

    
    alGenSources(1, &src);
    al_check_error();

    alGenBuffers(1, &buf);
    al_check_error();

    alBufferData(buf, AL_FORMAT_STEREO16, array, array_size, 44100);
    al_check_error();

    alSourcei(src, AL_BUFFER, buf);
//    alSourcei(src, AL_LOOPING, AL_TRUE);

    al_check_error();

    alSourcePlay(src);
    al_check_error();

}

char device_name[100] = {0};

int init_card(char * audio_fil_name)
{
    array = (char *) malloc(array_size);

    ALCdevice *dev = NULL;
    ALCcontext *ctx = NULL;

    const char *defname = alcGetString(NULL, ALC_DEFAULT_DEVICE_SPECIFIER);
    //std::cout << "Default device: " << defname << std::endl;

    strcpy (device_name, defname);

    dev = alcOpenDevice(defname);
    ctx = alcCreateContext(dev, NULL);
    alcMakeContextCurrent(ctx);



    /* Create buffer to store samples */

    
    return no_errors;
}


# define MAXCARDS 20
char *** cardslist = 0;

char *** cards_list(void)
{
	if (cardslist) free(cardslist);


	cardslist = (char ***) malloc(MAXCARDS * sizeof (char **));

	for (int i=0; i<MAXCARDS; i++)
		cardslist[i]= (char**) malloc (2 * sizeof (char *));	
	
	for (int i=0; i<MAXCARDS; i++)
	{
		for (int j=0; j<2; j++)
		{
			cardslist[i][j]= (char*) malloc (101 * sizeof (char));
			memset(cardslist[i][j], 0, 100);
		}
	}



    sprintf (cardslist[0][0], "%s", device_name);
    sprintf (cardslist[0][1], "%s", device_name);

    return (cardslist);
}