# define errors (-1)
# define no_errors 0


#include <alsa/asoundlib.h>

# include <linux/joystick.h>

# include "emulate.h"


snd_pcm_t *g_handle;

int init_failed = 0;


void play(char * buffer, int len)
{
    if (init_failed)
	return;


  snd_pcm_writei(g_handle, buffer, len/4);
}

int init_card(char * audio_fil_name)
{

    // open sound device and set params
      const static char *device = "default";

      snd_output_t *output = NULL;

   int err;

    if ((err = snd_pcm_open(&g_handle, device, SND_PCM_STREAM_PLAYBACK, 0)) < 0) 
    {
      fprintf(stderr, "Playback open error: %s\n", snd_strerror(err));
      init_failed = 1;
      return errors;
    }

    if ((err = snd_pcm_set_params(g_handle,
        SND_PCM_FORMAT_S16,
        SND_PCM_ACCESS_RW_INTERLEAVED,
        2,
        // BUF_LEN,
        44100,
        1, /* period */
        200000)) < 0) {	 /* latency: 0.5sec */ 
      fprintf(stderr, "Playback open error: %s\n", snd_strerror(err));
      init_failed = 1;
      return errors;
    }

return no_errors;
}


char Joy(void)
{
    static int first = 1;
    static int fd;
    char rv;
    
    if (first)
    {
	first = 0;
	fd = open ("/dev/input/js0", O_RDONLY);
    }

    if (fd==-1)
	return -1;

    struct JS_DATA_TYPE js;
    
    if (read (fd, &js, JS_RETURN) != JS_RETURN) 
    {
	return -1;
    }
    
    rv = 0;
    
                if (js.x<64)
                        rv |= 1;

                if (js.x>(128+64))
                        rv |= 2;
                
                if (js.y<65)
                        rv |= 8;
        
                if (js.y>(128+64))
                        rv |= 4;

                if (js.buttons)
                        rv |= 16;

    
    return rv;
}

# define MAXCARDS 20
char *** cardslist;

char *** cards_list(void)
{

	if (cardslist) free(cardslist);

	cardslist = (char ***) malloc(MAXCARDS * sizeof (char **));

	for (int i=0; i<MAXCARDS; i++)
		cardslist[i]= (char**) malloc (2 * sizeof (char *));	
	
	for (int i=0; i<MAXCARDS; i++)
	{
		for (int j=0; j<2; j++)
		{
			cardslist[i][j]= (char*) malloc (101 * sizeof (char));
			memset(cardslist[i][j], 0, 100);
		}
	}

    sprintf (cardslist[0][0], "default");
    sprintf (cardslist[0][1], "default");


    return (cardslist);
}